# conversation chronology class
# coding: utf-8

##   Copyright (C) 2010 Coopi <gnu@coopi.org>
## 
##   This program is free software; you can redistribute it and/or
##   modify it under the terms of the GNU General Public License as
##   published by the Free Software Foundation; either version 2 of the
##   License, or (at your option) any later version.
## 
##   This program is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##   General Public License for more details.
## 
##   You should have received a copy of the GNU General Public
##   License along with this program; if not, write to the
##   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

import pygtk
pygtk.require('2.0')
import gtk
import gtk.glade
import pango
import gobject
import os
import datetime

class crono:

	filter = ""

	# update chat counter
	def update_counter(self, number):
		if number == 1:
			self.lblCount.set_markup("<b>" + str(self.contatore) + _(" conversation") + "</b>")
		else:
			self.lblCount.set_markup("<b>" + str(self.contatore) + _(" conversations") + "</b>")

	# load conversations both into messages list and into the treeview
	# select only user conversations if user is specified
	# filter if filter is specified
	def load_chats(self, utente, filter=None):
		# empty chat list
		self.lstChats.get_model().clear()

		cursor = self.pygeon.conn.cursor()

		# create query
		if utente is None and filter is None:
			cursor.execute("select id, date, with, with_name, body from chats order by id desc")
		elif not utente is None and filter is None:
			cursor.execute("select id, date, with, with_name, body from chats where with = '" + self.pygeon.tdb(utente) + "' order by id desc")
		elif utente is None and not filter is None:
			cursor.execute("select id, date, with, with_name, body from chats where body like '%" + self.pygeon.tdb(filter) + "%' order by id desc")
		elif not utente is None and not filter is None:
			cursor.execute("select id, date, with, with_name, body from chats where with = '" + self.pygeon.tdb(utente) + "' and body like '%" + self.pygeon.tdb(filter) + "%' order by id desc")
		
		# create the progress bar
		conversations_list = cursor.fetchall()

		# close the window if the chat list is empty
		if self.filter == "" and len(conversations_list) == 0:
			self.cmdClose.clicked()
		else:
			self.pygeon.create_progress(self.progressCrono, len(conversations_list), True)
			current_step = 0

			self.contatore = 0

			for conversation in conversations_list:
				self.contatore = self.contatore + 1

				# increment the progress bar
				self.pygeon.set_progress(self.progressCrono, current_step, True)
				current_step = current_step + 1

				id = conversation[0]
				date = conversation[1]
				user = self.pygeon.fdb(conversation[2])
				with_name = self.pygeon.fdb(conversation[3])
				body = self.pygeon.fdb(conversation[4])

				# get the date
				date = datetime.datetime.strptime(date, "%d-%m-%Y %H.%M.%S").strftime("%d-%m-%y %H.%M")

				if date.startswith(datetime.date.today().strftime("%d-%m-%y")): date = _("Today at ") + date.split(' ')[1]
				elif date.startswith((datetime.date.today() - datetime.timedelta(days=1)).strftime("%d-%m-%y")): date = _("Yesterday at ") + date.split(' ')[1]
				else: date = datetime.datetime.strptime(date, "%d-%m-%y %H.%M").strftime(_("%d-%m-%y %H.%M"))

				# get user name from contact list if it isn't saved into db
				if with_name is None or with_name == "":
					with_name = self.pygeon.get_name_from_username(user)

				self.messages.append(conversation)

				if utente is None:
					self.lstChats.get_model().append([date + "\n<span foreground=\"#999999\"><small><i>" + with_name + "</i></small></span>", id, len(self.messages) - 1])
				else:
					self.lstChats.get_model().append([date, id, len(self.messages) - 1])
			
				while gtk.events_pending(): gtk.main_iteration_do(False)

				self.update_counter(self.contatore)
		
			self.update_counter(self.contatore) # if there aren't conversations this line of code is  necessary

			# destroy the progress bar
			self.pygeon.destroy_progress(self.progressCrono, True)
		
			# order messages by date
			self.cmdDesc.clicked()

			# select the first conversation if possible
			iter = self.lstChats.get_model().get_iter_first()
			if not iter is None:
				self.lstChats.get_selection().select_iter(iter)
				self.lstChats.scroll_to_cell(self.lstChats.get_model().get_path(iter))
				self.read_chat(self.lstChats.get_model().get_value(iter, 2))

	# read the message number 'number' from list
	def read_chat(self, number):
		utente = self.pygeon.fdb(self.messages[number][3])

		if utente is None or utente == "":
			# try to load the user from contact list
			utente = self.pygeon.get_name_from_username(self.pygeon.fdb(self.messages[number][2]))

		# add the text to textview
		self.txtChat.get_buffer().set_text(self.pygeon.fdb(self.messages[number][4]))

		# map timestamps
		self.pygeon.map_timestamps_and_status_to_message(utente, self.txtChat)

		# map urls
		self.pygeon.add_url_to_message(self.txtChat)

		# if the filter is specified apply the tag
		if self.filter != "": self.pygeon.apply_filter_to_message(self.txtChat, self.filter)

		# add emoticons to message
		self.pygeon.add_emoticons_to_message(self.txtChat)

	# click on conversation list
	def lstChats_clicked(self, widget):
		row = self.lstChats.get_selection().get_selected()

		self.read_chat(row[0].get_value(row[1], 2))

	# ascendent order by date
	def cmdAsc_clicked(self, widget):
		self.lstChats.get_model().set_sort_column_id(1, gtk.SORT_ASCENDING)

		# scroll to conversation if it is selected
		row = self.lstChats.get_selection().get_selected()

		if not row[1] is None:
			self.lstChats.scroll_to_cell(row[0].get_path(row[1]))
	
	# descendent order by date
	def cmdDesc_clicked(self, widget):
		self.lstChats.get_model().set_sort_column_id(1, gtk.SORT_DESCENDING)
		
		# scroll to conversation if it is selected
		row = self.lstChats.get_selection().get_selected()

		if not row[1] is None:
			self.lstChats.scroll_to_cell(row[0].get_path(row[1]))

	# remove the filter and reload conversation list
	def cmdClear_clicked(self, widget):
		if self.filter != "":
			self.filter = ""
			self.txtFilter.set_text("")
			self.txtChat.get_buffer().set_text("")
			self.load_chats(self.utente)

	# delete a conversation after a confirmation message
	def cmdElimina_clicked(self, widget):
		row = self.lstChats.get_selection().get_selected()

		if not row[1] is None and self.pygeon.message_box(_("Are you sure to delete the selected chat?"), _("Chat deletion"), gtk.MESSAGE_QUESTION, gtk.BUTTONS_YES_NO, self.winCrono) == gtk.RESPONSE_YES:
			cursor = self.pygeon.conn.cursor()
			cursor.execute("delete from chats where id = " + str(row[0].get_value(row[1], 1)))
			self.pygeon.conn.commit()
			cursor.close()

			# remove conversations from the treeview, but leave untouched the message list to avoid index to change
			self.lstChats.get_model().remove(row[1])

			# update counter and label
			self.contatore = self.contatore - 1
			self.update_counter(self.contatore)

			# try to select first conversation if possible
			iter = self.lstChats.get_model().get_iter_first()
			if not iter is None:
				self.lstChats.get_selection().select_iter(iter)
				self.lstChats.scroll_to_cell(self.lstChats.get_model().get_path(iter))
				self.read_chat(self.lstChats.get_model().get_value(iter, 2))
			else: # if there aren't conversations close the window or remove the filter
				if self.filter == "":
					self.cmdClose.clicked()
				else:
					self.cmdClear.clicked()

	# click on an url
	def txtChat_clicked(self, widget, event):
		self.pygeon.url_clicked(self.txtChat, event)

	# enter key in the textbox
	def txtFilter_activate(self, widget):
		# load conversations with filter
		filtro = self.txtFilter.get_text().strip()

		if filtro != "":
			self.filter = filtro
			self.txtChat.get_buffer().set_text("")
			self.load_chats(self.utente, filtro)

	# mouse move into textview
	def txtChat_mouse_move(self, widget, event):
		self.pygeon.url_move_on(self.txtChat, event)

	# window closing
	def delete_event(self, widget, event):
		self.pygeon.crono_classes.remove(self)
		if len(self.pygeon.read_message_classes) == 0 and len(self.pygeon.send_message_classes) == 0 and len(self.pygeon.chats) == 0 and len(self.pygeon.crono_classes) == 0: self.pygeon.unload_emoticons()
		self.winCrono.destroy()

	# click on close button
	def cmdClose_clicked(self, widget):
		self.pygeon.crono_classes.remove(self)
		if len(self.pygeon.read_message_classes) == 0 and len(self.pygeon.send_message_classes) == 0 and len(self.pygeon.chats) == 0 and len(self.pygeon.crono_classes) == 0: self.pygeon.unload_emoticons()
		self.winCrono.destroy()

	# constructor
	def __init__(self, pygeon, utente=None):
		self.pygeon = pygeon # main class
		self.utente = utente
		self.contatore = 0 # counter for label

		self.gladefile = "../data/glade/pygeon.glade"
		self.winContainer = gtk.glade.XML(self.gladefile, "winCrono")

		# glade objects
		self.winCrono = self.winContainer.get_widget("winCrono")
		self.cmdClose = self.winContainer.get_widget("cmdCronoClose")
		self.cmdAsc = self.winContainer.get_widget("cmdAsc")
		self.cmdDesc = self.winContainer.get_widget("cmdDesc")
		self.cmdClear = self.winContainer.get_widget("cmdClear")
		self.cmdElimina = self.winContainer.get_widget("cmdCronoElimina")
		self.imgClear = self.winContainer.get_widget("imgClear")
		self.imgCronoSortAsc = self.winContainer.get_widget("imgCronoSortAsc")
		self.imgCronoSortDesc = self.winContainer.get_widget("imgCronoSortDesc")
		self.imgCronoDelete = self.winContainer.get_widget("imgCronoDelete")
		self.imgCronoClose = self.winContainer.get_widget("imgCronoClose")
		self.lstChats = self.winContainer.get_widget("lstCronoChats")
		self.progressCrono = self.winContainer.get_widget("progressCrono")
		self.txtChat = self.winContainer.get_widget("txtCronoChat")
		self.txtFilter = self.winContainer.get_widget("txtFilter")
		self.lblFilter = self.winContainer.get_widget("lblFilter")
		self.lblClear = self.winContainer.get_widget("lblClear")
		self.lblCronoDelete = self.winContainer.get_widget("lblCronoDelete")
		self.lblCronoClose = self.winContainer.get_widget("lblCronoClose")
		self.lblCount = self.winContainer.get_widget("lblCount")

		self.lblFilter.set_markup(_("<b>Filter</b>"))
		self.lblClear.set_text(_("Clean"))
		self.lblCronoDelete.set_text(_("Delete"))
		self.lblCronoClose.set_text(_("Close"))

		self.imgClear.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "clear.png"))
		self.imgCronoSortAsc.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "sort_asc.png"))
		self.imgCronoSortDesc.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "sort_desc.png"))
		self.imgCronoDelete.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "delete.png"))
		self.imgCronoClose.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "close.png"))

		# signals
		self.winCrono.connect("delete_event", self.delete_event)
		self.cmdClose.connect("clicked", self.cmdClose_clicked)
		self.cmdAsc.connect("clicked", self.cmdAsc_clicked)
		self.cmdDesc.connect("clicked", self.cmdDesc_clicked)
		self.cmdClear.connect("clicked", self.cmdClear_clicked)
		self.cmdElimina.connect("clicked", self.cmdElimina_clicked)
		self.lstChats.connect("cursor_changed", self.lstChats_clicked)
		self.txtChat.connect("button_press_event", self.txtChat_clicked)
		self.txtChat.connect("motion_notify_event", self.txtChat_mouse_move)
		self.txtFilter.connect("activate", self.txtFilter_activate)

		self.winCrono.set_icon_from_file(os.path.normpath(self.pygeon.icon_application_path + "pygeon-small.png"))
		self.winCrono.set_title(_("Chronology manager"))

		self.cmdAsc.set_mode(False)
		self.cmdDesc.set_mode(False)

		# create the conversation list (date visible, id to sort, position into messages list)
		store = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_INT, gobject.TYPE_INT)
		self.lstChats.set_model(store)

		self.lstChats.append_column(gtk.TreeViewColumn("", gtk.CellRendererText(), markup=0))

		colonna_data = gtk.TreeViewColumn("", gtk.CellRendererText(), text=1)
		colonna_data.set_visible(False)

		colonna_pos = gtk.TreeViewColumn("", gtk.CellRendererText(), text=2)
		colonna_pos.set_visible(False)

		self.lstChats.append_column(colonna_data)
		self.lstChats.append_column(colonna_pos)

		# tags for textview
		self.txtChat.get_buffer().create_tag("timestamp_own", foreground = "#aa0000", size_points = 8)
		self.txtChat.get_buffer().create_tag("timestamp_other", foreground = "#0000aa", size_points = 8)
		self.txtChat.get_buffer().create_tag("status", foreground = "#888888", size_points = 8, justification = gtk.JUSTIFY_CENTER)
		self.txtChat.get_buffer().create_tag("url", foreground = "blue", underline = pango.UNDERLINE_SINGLE)
		self.txtChat.get_buffer().create_tag("filter", background = "orange")

		# load emoticons list if necessary
		if len(self.pygeon.read_message_classes) == 0 and len(self.pygeon.send_message_classes) == 0 and len(self.pygeon.chats) == 0 and len(self.pygeon.crono_classes) == 0: self.pygeon.load_emoticons()

		# messages list
		self.messages = []

		# load conversations
		self.load_chats(utente)
