# file manager window
# coding: utf-8

##   Copyright (C) 2010 Coopi <gnu@coopi.org>
## 
##   This program is free software; you can redistribute it and/or
##   modify it under the terms of the GNU General Public License as
##   published by the Free Software Foundation; either version 2 of the
##   License, or (at your option) any later version.
## 
##   This program is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##   General Public License for more details.
## 
##   You should have received a copy of the GNU General Public
##   License along with this program; if not, write to the
##   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

import pygtk
pygtk.require('2.0')
import gtk
import gtk.glade
import os

class file_manager:

	# window closing
	def delete_event(self, widget, event):
		# if there aren't transfers remove the class otherwise hide the window
		if len(self.elenco.get_children()) == 0:
			self.pygeon.file_manager_class = None			
			self.winFileManager.destroy()
		else:
			self.winFileManager.hide()
			return True

	# click on close button
	def cmdClose_clicked(self, widget, win):
		# if there aren't transfers remove the class otherwise hide the window
		if len(self.elenco.get_children()) == 0:
			self.pygeon.file_manager_class = None
			win.destroy()
		else:
			win.hide()

	# cancel a file transfer
	def cancel_transfer(self, widget, event, fid, to):
		# set to True cancelled variable of class file_transfer to stop the transfer
		self.pygeon.file_transfers[self.pygeon.get_file_transfer(fid)].cancelled = True

		# send a file transfer cancelled message to the sender/recipient
		self.pygeon.send_file_transfer_cancelled(to, fid)

	# constructor
	def __init__(self, pygeon):
		self.pygeon = pygeon # main class

		# build the window
		self.winFileManager = gtk.Window()
		self.winFileManager.connect("delete_event", self.delete_event)

		# create the scroll window
		scroll = gtk.ScrolledWindow()
		scroll.set_property("hscrollbar_policy", gtk.POLICY_NEVER)
		scroll.set_property("vscrollbar_policy", gtk.POLICY_AUTOMATIC)

		# create the close button
		imgClose = gtk.Image()
		imgClose.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "close.png"))

		lblClose = gtk.Label(_("Close"))
		lblClose.set_alignment(0.0, 0.5)

		hboxClose = gtk.HBox()
		hboxClose.pack_start(imgClose)
		hboxClose.pack_start(lblClose)

		self.cmdClose = gtk.Button()
		self.cmdClose.add(hboxClose)
		self.cmdClose.connect("clicked", self.cmdClose_clicked, self.winFileManager)

		# create the footer box
		footer = gtk.HBox()
		footer.pack_end(self.cmdClose, False)

		# create a vbox that contains all the hbox of file transfers
		self.elenco = gtk.VBox()
		self.elenco.set_spacing(5)

		scroll.add_with_viewport(self.elenco)

		# main vbox that contains all objects
		vbox = gtk.VBox()
		vbox.pack_start(scroll)
		vbox.pack_end(footer, False, True, 5)

		self.winFileManager.add(vbox)

		self.winFileManager.set_icon_from_file(os.path.normpath(self.pygeon.icon_application_path + "pygeon-small.png")) # set window icon
		self.winFileManager.set_title(_("File transfer"))

		self.winFileManager.set_default_size(400, 200)
		self.winFileManager.set_size_request(400, 200)

		self.winFileManager.show_all()

	# add a file transfer to window
	def add_file_transfer(self, fid, to):
		# label for filename and user
		lblInfo = gtk.Label()
		lblInfo.set_use_markup(True)
		lblInfo.set_alignment(0.0, 0.0)

		# progress bar
		progress = gtk.ProgressBar()

		# vertical container for label and progress bar
		vbox = gtk.VBox()
		vbox.pack_start(lblInfo, False)
		vbox.pack_start(progress, False)

		# button to cancel the transfer
		cmdCancel = gtk.Image()
		cmdCancel.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "cancel.png"))
		cmdCancel.set_alignment(0.0, 0.6)
		cancel_event = gtk.EventBox()
		cancel_event.set_visible_window(False)
		cancel_event.connect("button-press-event", self.cancel_transfer, fid, to)
		cancel_event.add(cmdCancel)

		# send/receive file image
		imgTransfer = gtk.Image()

		# main hbox that contains all objects
		hbox = gtk.HBox()
		hbox.pack_start(imgTransfer, False, True, 5)
		hbox.pack_start(vbox, True, True, 5)
		hbox.pack_start(cancel_event, False, True, 5)

		# add the box to the main vbox
		self.elenco.pack_start(hbox, False)

		# show the file transfer vbox
		self.winFileManager.show_all()

		# returns the objects needed for file_transfer class
		return lblInfo, imgTransfer, progress, hbox
