# send message class
# coding: utf-8

##   Copyright (C) 2010 Coopi <gnu@coopi.org>
## 
##   This program is free software; you can redistribute it and/or
##   modify it under the terms of the GNU General Public License as
##   published by the Free Software Foundation; either version 2 of the
##   License, or (at your option) any later version.
## 
##   This program is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##   General Public License for more details.
## 
##   You should have received a copy of the GNU General Public
##   License along with this program; if not, write to the
##   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

import pygtk
pygtk.require('2.0')
import gtk
import gtk.glade
import pango
import os
import datetime

class send_message:

	# window closing
	def delete_event(self, widget, event, data=None):
		self.pygeon.send_message_classes.remove(self)
		# unload emoticons variable if the read message window is closed
		if len(self.pygeon.read_message_classes) == 0 and len(self.pygeon.crono_classes) == 0 and len(self.pygeon.send_message_classes) == 0 and len(self.pygeon.chats) == 0: self.pygeon.unload_emoticons()
		self.winSend.destroy()

	# click on close button
	def cmdClose_clicked(self, widget):
		self.pygeon.send_message_classes.remove(self)
		# unload emoticons variable if the read message window is closed
		if len(self.pygeon.read_message_classes) == 0 and len(self.pygeon.crono_classes) == 0 and len(self.pygeon.send_message_classes) == 0 and len(self.pygeon.chats) == 0: self.pygeon.unload_emoticons()
		self.winSend.destroy()
	
	# send message
	def cmdSend_clicked(self, widget):
		# if the user isn't connected deny send
		if self.pygeon.cboStatus.get_active() == 3 or not self.pygeon.client.isConnected():
			self.pygeon.message_box(_("You must be connected to send the message"), _("Warning"), gtk.MESSAGE_WARNING, gtk.BUTTONS_OK, self.winSend)
			return

		# before send remove emoticons from message
		message = self.pygeon.remove_emoticons_from_message(self.txtBody)

		# remove spaces and \n at start and end of the string
		subject = self.txtSubject.get_text().strip('\n ')
		body = message.strip('\n ')

		# check if the subject is specified
		if subject == "":
			self.pygeon.message_box(_("You must insert the subject"), _("Warning"), gtk.MESSAGE_WARNING, gtk.BUTTONS_OK, self.winSend)
			self.txtSubject.grab_focus()

			return
		
		# check if the body is specified
		if body == "":
			self.pygeon.message_box(_("You must insert the message"), _("Warning"), gtk.MESSAGE_WARNING, gtk.BUTTONS_OK, self.winSend)
			self.txtBody.grab_focus()

			return

		# check the maximum size of the message
		if len(body) > self.pygeon.max_message_length:
			self.pygeon.message_box(_("The message exceeded the maximum lenght of ") + str(self.pygeon.max_message_length) + _(" characters"), _("Warning"), gtk.MESSAGE_WARNING, gtk.BUTTONS_OK, self.winSend)
			self.txtBody.grab_focus()

			return

		# if all is ok send message
		# if it's a broadcast or a multiple message send n messages
		if not self.to is None: # single message
			self.pygeon.send_message(self.to, "normal", subject, body)
		elif self.to is None and len(self.utenti) == 0: # broadcast
			iter = self.pygeon.lstUtenti.get_model().get_iter_first()

			while not iter is None:
				if self.chkBroadcast.get_active() or (not self.chkBroadcast.get_active() and self.pygeon.lstUtenti.get_model().get_value(iter, 3) != 3):
					self.pygeon.send_message(self.pygeon.lstUtenti.get_model().get_value(iter, 4), "normal", subject, body)

				iter = self.pygeon.lstUtenti.get_model().iter_next(iter)
		elif self.to is None and len(self.utenti) > 0: # multiple message
			for utente in self.utenti:
				self.pygeon.send_message(utente, "normal", subject, body)
		
		# close the window
		self.cmdClose.clicked()

	# click on emoticon
	def emoticon_clicked(self, widget, path):
		if self.pygeon.debug: print _("You clicked on the emoticon: ") + path + _(" which corresponds to: ") + self.pygeon.emoticons_symbol[self.pygeon.emoticons_path.index(path)]

		# add the pixbuf into the textview
		if self.pygeon.emoticons_pixbuf[self.pygeon.emoticons_path.index(path)] is None:
			self.pygeon.emoticons_pixbuf[self.pygeon.emoticons_path.index(path)] = gtk.gdk.pixbuf_new_from_file(path)
			if self.pygeon.debug: print _("I created the pixbuf for: ") + self.pygeon.emoticons_symbol[self.pygeon.emoticons_path.index(path)]
		
		iter = self.txtBody.get_buffer().get_iter_at_offset(self.txtBody.get_buffer().get_property("cursor_position"))
		self.txtBody.get_buffer().insert_pixbuf(iter, self.pygeon.emoticons_pixbuf[self.pygeon.emoticons_path.index(path)])

		# destroy the window
		self.winEmoticon.destroy()

		# grab focus on textview
		self.txtBody.grab_focus()

	# emoticon window closing
	def winEmoticon_delete(self, widget, event):
		self.winEmoticon.destroy()
		
		# grab focus on textview
		self.txtBody.grab_focus()

	# create and show emoticons window
	def cmdEmoticon_clicked(self, widget):
		self.winEmoticon = gtk.Window()
		vbox = gtk.VBox()

		hbox1 = gtk.HBox()
		hbox2 = gtk.HBox()
		hbox3 = gtk.HBox()
		hbox4 = gtk.HBox()
		hbox5 = gtk.HBox()
		hbox6 = gtk.HBox()

		vbox.pack_start(hbox1)
		vbox.pack_start(hbox2)
		vbox.pack_start(hbox3)
		vbox.pack_start(hbox4)
		vbox.pack_start(hbox5)
		vbox.pack_start(hbox6)

		# load emoticons
		for file in self.pygeon.emoticons_path:
			image = gtk.Image()
			image.set_from_file(file)
			button = gtk.Button()
			button.set_image(image)

			if len(hbox1.get_children()) < 5: hbox1.pack_start(button, False)
			elif len(hbox2.get_children()) < 5: hbox2.pack_start(button, False)
			elif len(hbox3.get_children()) < 5: hbox3.pack_start(button, False)
			elif len(hbox4.get_children()) < 5: hbox4.pack_start(button, False)
			elif len(hbox5.get_children()) < 5: hbox5.pack_start(button, False)
			else: hbox6.pack_start(button, False)

			button.connect("clicked", self.emoticon_clicked, file)
			
		self.winEmoticon.add(vbox)
		self.winEmoticon.set_modal(True)
		self.winEmoticon.set_icon_from_file(os.path.normpath(self.pygeon.icon_application_path + "pygeon-small.png"))
		self.winEmoticon.set_resizable(False)
		self.winEmoticon.set_title(":)")

		self.winEmoticon.connect("delete_event", self.winEmoticon_delete)

		self.winEmoticon.show_all()

	# click on url
	def txtBody_clicked(self, widget, event):
		self.pygeon.url_clicked(self.txtBody, event)

	# mouse move into the textview
	def txtBody_mouse_move(self, widget, event):
		self.pygeon.url_move_on(self.txtBody, event)

	# constructor
	# if to=None send a broacast if 'utenti' isn't specified. if 'utenti' is specified send a multiple message
	def __init__(self, pygeon, to=None, subject=None, body=None, date=None, utenti=[]):
		self.pygeon = pygeon # main class
		self.to = to # recipient
		self.utenti = utenti # recipients

		self.gladefile = "../data/glade/pygeon.glade"
		self.winContainer = gtk.glade.XML(self.gladefile, "winSend")

		# glade objects
		self.winSend = self.winContainer.get_widget("winSend")
		self.lblTo = self.winContainer.get_widget("lblTo")
		self.lblSendSubject = self.winContainer.get_widget("lblSendSubject")
		self.lblSend = self.winContainer.get_widget("lblSend")
		self.lblSendClose = self.winContainer.get_widget("lblSendClose")
		self.lblNecessario = self.winContainer.get_widget("lblNecessario")
		self.txtSubject = self.winContainer.get_widget("txtSendSubject")
		self.txtBody = self.winContainer.get_widget("txtSendBody")
		self.cmdClose = self.winContainer.get_widget("cmdSendClose")
		self.cmdSend = self.winContainer.get_widget("cmdSendMessage")
		self.cmdEmoticon = self.winContainer.get_widget("cmdEmoticon")
		self.imgEmoticon = self.winContainer.get_widget("imgEmoticon")
		self.chkBroadcast = self.winContainer.get_widget("chkBroadcast")
		self.imgClose = self.winContainer.get_widget("imgSendClose")
		self.imgSend = self.winContainer.get_widget("imgSendMessage")

		self.lblSendSubject.set_markup(_("<b>Subject:</b>"))
		self.lblSend.set_text(_("Send"))
		self.lblSendClose.set_text(_("Close"))
		self.lblNecessario.set_markup(_("<small>Send also to offline contacts\n(Use only if necessary)</small>"))

		# signals
		self.winSend.connect("delete_event", self.delete_event)
		self.cmdClose.connect("clicked", self.cmdClose_clicked)
		self.cmdSend.connect("clicked", self.cmdSend_clicked)
		self.cmdEmoticon.connect("clicked", self.cmdEmoticon_clicked)
		self.txtBody.connect("button_press_event", self.txtBody_clicked)
		self.txtBody.connect("motion_notify_event", self.txtBody_mouse_move)

		self.imgEmoticon.set_from_file(os.path.normpath(self.pygeon.icon_theme_emoticons_path + "face-smile.png"))
		self.imgClose.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "close.png"))
		self.imgSend.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "message_big.png"))
		
		self.winSend.set_icon_from_file(os.path.normpath(self.pygeon.icon_application_path + "pygeon-small.png")) # window icon

		# load emoticons list if unloaded
		if len(self.pygeon.read_message_classes) == 0 and len(self.pygeon.crono_classes) == 0 and len(self.pygeon.send_message_classes) == 0 and len(self.pygeon.chats) == 0: self.pygeon.load_emoticons()

		if not to is None:
			user = self.pygeon.get_name_from_username(to.partition('/')[0]) # get the user name

			self.lblTo.set_markup(_("<b>Recipient:</b> ") + user)
			self.winSend.set_title(_("Send message"))
		elif to is None and len(utenti) == 0: 
			self.lblTo.set_markup(_("<b>Recipients:</b> All users"))
			self.winSend.set_title(_("Send broadcast"))
			self.chkBroadcast.show()
		elif to is None and len(utenti) > 0: 
			destinatari = ""
			for utente in utenti:
				if destinatari == "":
					destinatari = self.pygeon.get_name_from_username(utente)
				else:
					destinatari = destinatari + ", " + self.pygeon.get_name_from_username(utente)

			self.lblTo.set_markup(_("<b>Recipients:</b> ") + destinatari)
			self.winSend.set_title(_("Send multiple message"))

		if not subject is None: self.txtSubject.set_text(subject) # subject
		if not body is None: # if the body is specified it's a reply and the body is quoted
			
			# check the date
			if not date is None: body_header = _("On ") + datetime.datetime.strptime(date, "%d-%m-%Y %H.%M.%S").strftime(_("%d-%m-%Y %H.%M.%S")) + ", "
			else: body_header = ""

			body_header = body_header + user + _(" wrote:\n")
			body = ">" + body.replace('\n', '\n>')

			self.txtBody.get_buffer().create_tag("quote", foreground = "#888888")
			self.txtBody.get_buffer().create_tag("url", foreground = "blue", underline = pango.UNDERLINE_SINGLE)
			self.txtBody.get_buffer().create_tag("normale")

			self.txtBody.get_buffer().insert_with_tags_by_name(self.txtBody.get_buffer().get_start_iter(), body_header, "normale")
			self.txtBody.get_buffer().insert_with_tags_by_name(self.txtBody.get_buffer().get_end_iter(), body, "quote")
			self.txtBody.get_buffer().insert_with_tags_by_name(self.txtBody.get_buffer().get_end_iter(), "\n\n", "normale")

			# add urls to message
			self.pygeon.add_url_to_message(self.txtBody)

			# add emoticons to message
			self.pygeon.add_emoticons_to_message(self.txtBody)

			self.txtBody.scroll_to_mark(self.txtBody.get_buffer().create_mark(None, self.txtBody.get_buffer().get_end_iter(), False), 0.0)
			self.txtBody.grab_focus()
