# tray icon class
# coding: utf-8

##   Copyright (C) 2010 Coopi <gnu@coopi.org>
## 
##   This program is free software; you can redistribute it and/or
##   modify it under the terms of the GNU General Public License as
##   published by the Free Software Foundation; either version 2 of the
##   License, or (at your option) any later version.
## 
##   This program is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##   General Public License for more details.
## 
##   You should have received a copy of the GNU General Public
##   License along with this program; if not, write to the
##   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

import pygtk
pygtk.require('2.0')
import gtk
import os

from pref import pref
from read_message import read_message

class tray:

	# left click on tray icon
	def activate(self, widget):
		if self.tray.get_blinking(): # open the read message window if it's closed
			if self.pygeon.count_messages(2) > 0:
				classe = self.pygeon.get_read_message(2)

				if classe is None:
					self.pygeon.read_message_classes.append(read_message(self.pygeon, 2))
				else:
					classe.winRead.present()

			# show all chat windows if present
			for classe in self.pygeon.chats:
				if not classe.winChat.get_property("visible"):
					classe.winChat.show()
					self.pygeon.remove_chat_from_contact(classe.to)

		else: # show/hide main window if it isn't blinking
			self.pygeon.winMain.set_property("visible", not self.pygeon.winMain.get_property("visible"))

	# show the contact list if not visible
	def mnuHome_activate(self, widget):
		if not self.pygeon.winMain.get_property("visible"): self.pygeon.winMain.set_property("visible", True)

	# right click on tray icon
	def popup(self, widget, button, time, data=None):
		self.menu.popup(None, None, None, button, time)

	# click on available on popup menu
	def mnuDisponibile_activate(self, widget):
		self.pygeon.cboStatus.set_active(0)
	
	# click on away on popup menu
	def mnuAssente_activate(self, widget):
		self.pygeon.cboStatus.set_active(1)
	
	# click on not available on popup menu
	def mnuOccupato_activate(self, widget):
		self.pygeon.cboStatus.set_active(2)
	
	# click on offline on popup menu
	def mnuOffline_activate(self, widget):
		self.pygeon.cboStatus.set_active(3)

	# click on preferences on popup menu
	def mnuPreferenze_activate(self, widget):
		if self.pygeon.pref_class is None: pref(self.pygeon)

	# click on no sound on popup menu
	def mnuSuono_activate(self, widget):
		self.pygeon.mute = self.mnuSuono.get_active()

		# if preferences window is opened change sounds settings in real-time mode
		if not self.pygeon.pref_class is None:
			# from mute to non-mute reload the options before enable/disable from variables
			if not self.pygeon.mute:
				self.pygeon.pref_class.chkRicevuto.set_sensitive(True)
				self.pygeon.pref_class.chkRicevuto.set_active(self.pygeon.sounds_receive)
				self.pygeon.pref_class.chkConnesso.set_sensitive(True)
				self.pygeon.pref_class.chkConnesso.set_active(self.pygeon.sounds_connect)
				self.pygeon.pref_class.chkDisconnesso.set_sensitive(True)
				self.pygeon.pref_class.chkDisconnesso.set_active(self.pygeon.sounds_disconnect)

			self.pygeon.pref_class.set_ricevuto_sensitive()
			self.pygeon.pref_class.set_connesso_sensitive()
			self.pygeon.pref_class.set_disconnesso_sensitive()

	# click on quit button on popup menu
	def mnuEsci_activate(self, widget):
		self.pygeon.close_program()
		gtk.main_quit()

	# constructor
	def __init__(self, pygeon):
		self.pygeon = pygeon # main window

		# create the tray icon
		self.tray = gtk.StatusIcon()
		self.tray.set_visible(True)

		# create the popup menu
		self.menu = gtk.Menu()

		# add status
		self.mnuDisponibile = gtk.ImageMenuItem(_("Available"))
		self.imgDisponibile = gtk.Image()
		self.imgDisponibile.set_from_file(os.path.normpath(self.pygeon.icon_theme_status_path + "available.png"))
		self.mnuDisponibile.set_image(self.imgDisponibile)
		self.mnuDisponibile.set_property("always-show-image", True)
		self.menu.append(self.mnuDisponibile)
		
		self.mnuAssente = gtk.ImageMenuItem(_("Away"))
		self.imgAssente = gtk.Image()
		self.imgAssente.set_from_file(os.path.normpath(self.pygeon.icon_theme_status_path + "away.png"))
		self.mnuAssente.set_image(self.imgAssente)
		self.mnuAssente.set_property("always-show-image", True)
		self.menu.append(self.mnuAssente)
		
		self.mnuOccupato = gtk.ImageMenuItem(_("Not available"))
		self.imgOccupato = gtk.Image()
		self.imgOccupato.set_from_file(os.path.normpath(self.pygeon.icon_theme_status_path + "dnd.png"))
		self.mnuOccupato.set_image(self.imgOccupato)
		self.mnuOccupato.set_property("always-show-image", True)
		self.menu.append(self.mnuOccupato)
		
		self.mnuOffline = gtk.ImageMenuItem(_("Offline"))
		self.imgOffline = gtk.Image()
		self.imgOffline.set_from_file(os.path.normpath(self.pygeon.icon_theme_status_path + "offline.png"))
		self.mnuOffline.set_image(self.imgOffline)
		self.mnuOffline.set_property("always-show-image", True)
		self.menu.append(self.mnuOffline)

		# separator
		self.sepStatus = gtk.SeparatorMenuItem()
		self.menu.append(self.sepStatus)

		# preferences
		self.mnuPreferenze = gtk.ImageMenuItem(_("Preferences"))
		self.imgPreferences = gtk.Image()
		self.imgPreferences.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "preferences.png"))
		self.mnuPreferenze.set_image(self.imgPreferences)
		self.mnuPreferenze.set_property("always-show-image", True)
		self.menu.append(self.mnuPreferenze)

		# separator
		self.sepPreferenze = gtk.SeparatorMenuItem()
		self.menu.append(self.sepPreferenze)
		
		# show contact list
		self.mnuHome = gtk.ImageMenuItem(_("Show contact list"))
		self.imgHome = gtk.Image()
		self.imgHome.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "contact_list.png"))
		self.mnuHome.set_image(self.imgHome)
		self.mnuHome.set_property("always-show-image", True)
		self.menu.append(self.mnuHome)

		# no sound
		self.mnuSuono = gtk.CheckMenuItem(_("No sound"))
		self.mnuSuono.set_active(self.pygeon.mute)
		self.menu.append(self.mnuSuono)

		# separator
		self.sepSuono = gtk.SeparatorMenuItem()
		self.menu.append(self.sepSuono)

		# quit
		self.mnuEsci = gtk.ImageMenuItem(_("Quit"))
		self.imgQuit = gtk.Image()
		self.imgQuit.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "quit.png"))
		self.mnuEsci.set_image(self.imgQuit)
		self.mnuEsci.set_property("always-show-image", True)
		self.menu.append(self.mnuEsci)

		self.menu.show_all()

		# signals
		self.tray.connect("activate", self.activate)
		self.tray.connect("popup_menu", self.popup)
		self.mnuDisponibile.connect("activate", self.mnuDisponibile_activate)
		self.mnuAssente.connect("activate", self.mnuAssente_activate)
		self.mnuOccupato.connect("activate", self.mnuOccupato_activate)
		self.mnuOffline.connect("activate", self.mnuOffline_activate)
		self.mnuPreferenze.connect("activate", self.mnuPreferenze_activate)
		self.mnuHome.connect("activate", self.mnuHome_activate)
		self.mnuSuono.connect("activate", self.mnuSuono_activate)
		self.mnuEsci.connect("activate", self.mnuEsci_activate)
